#include <PalmOS.h>
#include <StringMgr.h>
#include <VFSMgr.h>

#include "AppRsc.h"
#include "pnobridge.h"

#include "App_Fx.h"

#include "Host68k.h"
#include "TapWave/TwChars.h"

#include <PalmOS.h>



extern int g_num_entries;
extern char **g_listchoice;


#define MAX_LISTED 1024


void Sort_Entries(char **listchoice,int num)
{
	int i,j;
    char *a,*b;

    if (num<2)
      return;
    
    for (i=0;i<num;i++)
      {
        for (j=0;j<num-1;j++)
          {
          	a=listchoice[j];//+3;
          	b=listchoice[j+1];//+3;
            if (StrCaselessCompare(a, b)>0)
              {
                char * temp;
                temp = listchoice[j];
                listchoice[j] = listchoice[j+1];
                listchoice[j+1] = temp;
              }
          }
      }
}


void InitFileList(ListType *list,char *selection)
{
	Err			err = errNone;
	char		tmpName[128];
	int 		cur_entry=0;	
	int 		total_size=0;
	UInt16 		volRefNum;			
	UInt32 		volIterator; 
	
	g_num_entries = MAX_LISTED;
	g_listchoice=(char**)MemPtrNew(g_num_entries*sizeof(char*));	


	if (!g_listchoice) 			
	{		
		LstSetListChoices(list,(char**)NULL,0);		
		menu_inform("Browser : not enough memory!");
		return;
	}			


	volIterator = vfsIteratorStart;
	while (volIterator != vfsIteratorStop) 
	{
		err = VFSVolumeEnumerate(&volRefNum, &volIterator);
		if (!err) 
		{
			FileInfoType info;
			FileRef dirRef;
			UInt32 dirIterator;					
			// open the directory first, to get the directory reference
			// volRefNum must have already been defined
			
			err = VFSFileOpen(volRefNum, VFSPATH, vfsModeRead, &dirRef);
			if(err == errNone) 
			{
				info.nameP = tmpName; // point to local buffer												
				info.nameBufLen = 127;
				dirIterator = vfsIteratorStart;
				while (dirIterator != vfsIteratorStop) 
				{
				
					// Get the next file
					err = VFSDirEntryEnumerate (dirRef, &dirIterator,&info);
					if (err == errNone) 
					{
						// Do something with the directory entry information
						// Pull the attributes from info.attributes
						// The file name is in fileName
						char ext[5];
						char *qext,*pext;
						int add_entry=1;
						qext = info.nameP;
						pext = NULL;

						/*while (qext = StrChr(qext, '.'))
						{
							pext = qext;
							qext++;
						}
														
						if (pext) {
							StrNCopy(ext, pext, 4);
							ext[4]=0;
						}
						else ext[0]=0;	*/
						
						if ( !(info.attributes&vfsFileAttrDirectory)/*StrCaselessCompare(ext, ".wad") != 0*/)
						{
							add_entry=0;
						}
						if (add_entry)
						{								
							g_listchoice[cur_entry] = (char*)MemPtrNew(StrLen(tmpName)+1);//+3);
							if (!g_listchoice[cur_entry]) {
								DEBUGS("MemPtrNew error g_listchoice[cur_entry]");
								break;
							}
							//StrCopy(g_listchoice[cur_entry],"_");
							//g_listchoice[cur_entry][0]=volRefNum;
							StrCopy(g_listchoice[cur_entry],tmpName);
							total_size+=StrLen(tmpName)+1;//+1;
							cur_entry++;
							if (cur_entry>=g_num_entries) break;
							info.nameP = tmpName;
							info.nameBufLen = 127;
						}
					}
					else break;
				} 
			}
			else 
			{
				// handle error, possibly by breaking out of the loop

				break;
			}
			VFSFileClose (dirRef);
		} 
		else 
		{
			// handle directory open error here

			break;
		}
		if (cur_entry>=g_num_entries) break;
	}

    if (cur_entry==g_num_entries)
    {
    	char str[128];
    	StrPrintF(str,"Cannot show more than %d files",g_num_entries);
    	menu_inform(str);

    }

			
	if (cur_entry)
	{
		signed short selindex=-1;
		int i;

		Sort_Entries(g_listchoice,cur_entry);

		for (i=0;i<cur_entry;i++)
		if (StrCompare(selection,g_listchoice[i])==0)
		{selindex=i;break;}

		LstSetListChoices(list,(char**)NULL,cur_entry);

		if (selindex>=0) {
			LstMakeItemVisible(list,selindex);
			LstSetSelection(list,selindex);
		}
		else {
			LstMakeItemVisible(list,0);
			LstSetSelection(list,0);
		}
		g_num_entries=cur_entry;

	}
	else
	{		
		MemPtrFree(g_listchoice);
		g_listchoice=NULL;
		LstSetListChoices(list,(char**)NULL,0);		
//		menu_inform("No Wad!");
	}
	

}
