#define _tapwave_os_stuff_

#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "AppRsc.h"
#include "oscompat.h"

int errno = 0;

#define F_DEBUGLOG 1
void debuglog ( char *poo ) {
#ifdef F_DEBUGLOG
#define MAXDLOG 3
  static char debug [ MAXDLOG ][ 100 ];
  static UInt16 debuglogn = 0;
  static UInt8 nomore = 0;
  char *c;

  if ( ! poo ) {
    nomore = 1;
  }

  if ( nomore ) {
    return; // stopped
  }

  // quick draw to top
  //WinDrawChars ( poo, StrLen ( poo ), 0, 0 );
  //return;

  // normal debuglog
  if ( c = StrChr ( poo, '\n' ) ) {
    *c = '\0';
  }

#if 1
  Int8 iter;
  UInt8 y = 0;

  // dumb
  if ( debuglogn == MAXDLOG - 1 ) {
    for ( iter = 1; iter < MAXDLOG; iter++ ) {
      StrNCopy ( debug [ iter - 1 ], debug [ iter ], 99 );
    }
  }

  MemSet ( debug [ debuglogn ], 100, '\0' );
  StrNCopy ( debug [ debuglogn ], poo, 97 );
  StrNCat ( debug [ debuglogn ], "   ", 99 );

  if ( debuglogn < MAXDLOG - 1 ) {
    debuglogn++;
  }

  // display
  for ( iter = 0; iter < MAXDLOG; iter++ ) {
    char *text = debug [ iter ];
    if ( text ) {
      WinDrawChars ( "                              "
		     "                              "
		     "                              ",
		     90, 0, ( 10 * iter ) + 130 );
      WinDrawChars ( text, StrLen ( text ), 0, ( 10 * iter ) + ( 160 - ( 10 * MAXDLOG ) ) );
    }
  }

#if 0
  {
    UInt32 timmy = TimGetSeconds();
    while ( TimGetSeconds() == timmy );
  }
#endif

#else
  FrmCustomAlert ( MessageAlert, poo, NULL, NULL );
#endif

#endif
  return;
}

/*void *memcpy ( void *d, const void *s, unsigned int size ) {
  MemMove ( d, s, size );
  return ( d );
}*/

/*void *memset ( void *b, int c, unsigned int len ) {
  MemSet ( b, len, c );
  return ( b );
}*/

#ifndef _tapwave_os_stuff_
void *malloc ( unsigned int s ) {
  //DEBUGU8 ( s );
  void *p = MemGluePtrNewL ( s );
  if ( ! p ) {
    //DEBUGS ( "Couldn't allocate memory!" );
    //DEBUGU32 ( s );
  }
  return ( p );
}

void *calloc ( unsigned int s, unsigned int n ) {
  UInt8 *p = MemGluePtrNewL ( s * n );
  if (p) memset ( p, 0, s * n );
  return ( p );
}

void free ( void *p ) {
  MemPtrFree ( p );
}

void *realloc ( UInt8 *p, UInt32 s ) {
  UInt8 *newbie;

  newbie = malloc/*MemGluePtrNewL*/ ( s );

  if ( ! newbie ) {
    DEBUGS ( "realloc crash" );
    return ( NULL );
  }

  if ( ! p ) {
    return ( newbie );
  }

  if ( s < MemPtrSize ( p ) ) {
    MemMove ( newbie, p, s );
  } else {
    MemMove ( newbie, p, MemPtrSize ( p ) );
  }

  free/*MemPtrFree*/ ( p );
  //MemPtrResize ( p, s );
  return ( newbie );
}
#else

extern UInt32 currentOwnerID;
void*
__sys_alloc(size_t size)
{
    void * ptr = MemChunkNew(0,size,0x1200|currentOwnerID);//MemGluePtrNewL(size);//MemPtrNew(size);    
    if (ptr == NULL){
    	/*char msg[32];
    	int bytes,max;
    	sprintf(msg,"cannot sys_alloc %d Bytes.",size);
    	Sys_PrintF(msg);
    	menu_info(" ");
    	MemHeapFreeBytes ( 0, &bytes, &max );
	  	Sys_PrintF("free ram : %d/%d",bytes>>10,max>>10);
		menu_info(" ");
	    //ErrFatalDisplayIf(ptr == NULL, msg);*/
	}
    return ptr;
}

void
__sys_free(void* ptr)
{
    (void) MemChunkFree/*MemPtrFree*/(ptr);
}

size_t
__sys_pointer_size(void* ptr)
{
    return (size_t) MemPtrSize(ptr);
}

#endif

void abort ( void ) {
  DEBUGS ( "PNG abort" );
}

/*int abs ( int x ) {
  if ( x < 0 ) {
    return ( x * -1 );
  }
  return ( x );
}*/


void raise ( int ) {
  DEBUGS ( "raise error" );
  while(1);
  return;
}


